//+------------------------------------------------------------------+
//|                                                 ScalperDream.mq4 |
//|                                              Copyright 2015, AM2 |
//|                                      http://www.forexsystems.biz |
//+------------------------------------------------------------------+
#property copyright "Copyright  2015, AM2"
#property link      "http://www.forexsystems.biz"
#property description "Simple expert advisor"

//--- Inputs
extern int    StopLoss     = 500; // 
extern int    TakeProfit   = 500; // 
extern int    TrailingStop = 300; // 
extern int    Slip         = 30;  // 
extern int    StartHour    = 0;   //   
extern int    StartMin     = 10;  //   
extern int    EndHour      = 23;  //   
extern int    EndMin       = 55;  //   
extern int    CloseAfter   = 0;   //       0-. 1-.
extern int    Magic        = 123; // 
extern double Lots         = 0.1; // 
//----
extern string IndName="Scalper Dream"; //  
extern int    SDPeriod     = 28;  //   Scalper Dream
extern double SarStep      = 0.02;//    Sar - 
extern double SarMaximum   = 0.2; //       Sar
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---

//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---

  }
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void OpenPos()
  {
   int r=0;
   double sl=0,tp=0;
//--- get Ind
   double SDGreen=iCustom(Symbol(),0,IndName,SDPeriod,0,1);
   double SDRed=iCustom(Symbol(),0,IndName,SDPeriod,1,1);
   double Sar=iSAR(Symbol(),0,SarStep,SarMaximum,1);

//--- sell conditions
   if(SDRed>0 && Bid<Sar)
     {
      if(StopLoss>0) sl=NormalizeDouble(Bid+StopLoss*Point,Digits);
      if(TakeProfit>0) tp=NormalizeDouble(Bid-TakeProfit*Point,Digits);
      r=OrderSend(Symbol(),OP_SELL,Lots,NormalizeDouble(Bid,Digits),Slip,sl,tp,"",Magic,0,Red);
     }
//--- buy conditions
   if(SDGreen>0 && Ask>Sar)
     {
      if(StopLoss>0) sl=NormalizeDouble(Ask-StopLoss*Point,Digits);
      if(TakeProfit>0) tp=NormalizeDouble(Ask+TakeProfit*Point,Digits);
      r=OrderSend(Symbol(),OP_BUY,Lots,NormalizeDouble(Ask,Digits),Slip,sl,tp,"",Magic,0,Blue);
     }
//---
  }
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void ClosePos()
  {
   double SDGreen=iCustom(Symbol(),0,IndName,SDPeriod,0,1);
   double SDRed=iCustom(Symbol(),0,IndName,SDPeriod,1,1);
   double Sar=iSAR(Symbol(),0,SarStep,SarMaximum,1);
//---
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderMagicNumber()!=Magic || OrderSymbol()!=Symbol()) continue;
      //--- check order type 
      if(OrderType()==OP_BUY)
        {
         if(SDRed>0 && Bid<Sar)
           {
            if(!OrderClose(OrderTicket(),OrderLots(),Bid,Slip,White))
               Print("OrderClose error ",GetLastError());
           }
         break;
        }
      if(OrderType()==OP_SELL)
        {
         if(SDGreen>0 && Ask>Sar)
           {
            if(!OrderClose(OrderTicket(),OrderLots(),Ask,Slip,White))
               Print("OrderClose error ",GetLastError());
           }
         break;
        }
     }
//---
  }  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Trailing()
  {
   bool mod;
   for(int i=0; i<OrdersTotal(); i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==Symbol() || OrderMagicNumber()==Magic)
           {
            if(OrderType()==OP_BUY)
              {
               if(TrailingStop>0)
                 {
                  if(Bid-OrderOpenPrice()>TrailingStop*Point)
                    {
                     if(OrderStopLoss()<Bid-TrailingStop*Point)
                       {
                        mod=OrderModify(OrderTicket(),OrderOpenPrice(),Bid-TrailingStop*Point,OrderTakeProfit(),0,Yellow);
                        return;
                       }
                    }
                 }
              }

            if(OrderType()==OP_SELL)
              {
               if(TrailingStop>0)
                 {
                  if((OrderOpenPrice()-Ask)>TrailingStop*Point)
                    {
                     if((OrderStopLoss()>(Ask+TrailingStop*Point)) || (OrderStopLoss()==0))
                       {
                        mod=OrderModify(OrderTicket(),OrderOpenPrice(),Ask+TrailingStop*Point,OrderTakeProfit(),0,Yellow);
                        return;
                       }
                    }
                 }
              }
           }
        }
     }
  }
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 30.04.2009                                                     |
//|   :      .                |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    hb -                                           |
//|    mb -                                         |
//|    he -                                        |
//|    me -                                      |
//+----------------------------------------------------------------------------+
bool isTradeTimeInt(int hb=0,int mb=0,int he=0,int me=0)
  {
   datetime db, de;           //     
   int      hc;               //     

   db=StrToTime(TimeToStr(TimeCurrent(), TIME_DATE)+" "+hb+":"+mb);
   de=StrToTime(TimeToStr(TimeCurrent(), TIME_DATE)+" "+he+":"+me);
   hc=TimeHour(TimeCurrent());

   if(db>=de)
     {
      if(hc>=he) de+=24*60*60; else db-=24*60*60;
     }

   if(TimeCurrent()>=db && TimeCurrent()<=de) return(True);
   else return(False);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CloseAll()
  {
   bool del;
   for(int i=OrdersTotal()-1;i>=0;i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
           {
            if(OrderType()==OP_BUY)  del=OrderClose(OrderTicket(),OrderLots(),Bid,Slip,White);
            if(OrderType()==OP_SELL) del=OrderClose(OrderTicket(),OrderLots(),Ask,Slip,White);
           }
        }
     }
   return;
  }
//+------------------------------------------------------------------+
int CountTrades()
  {
   int count=0;
   for(int i=OrdersTotal()-1;i>=0;i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
           {
            if(OrderType()==OP_BUY || OrderType()==OP_SELL) count++;
           }
        }
     }
   return(count);
  }
//+------------------------------------------------------------------+
//| OnTick function                                                  |
//+------------------------------------------------------------------+
void OnTick()
  {
   double SDGreen=iCustom(Symbol(),0,IndName,SDPeriod,0,1);
   double SDRed=iCustom(Symbol(),0,IndName,SDPeriod,1,1);
   double Sar=iSAR(Symbol(),0,SarStep,SarMaximum,1);

   if(isTradeTimeInt(StartHour,StartMin,EndHour,EndMin))
     {
      if(CountTrades()<1)
        {
         OpenPos();
        }
     }

   if(!isTradeTimeInt(StartHour,StartMin,EndHour,EndMin) && CloseAfter==1)CloseAll();
   if(TrailingStop!=0) Trailing();
   if(CountTrades()>0) ClosePos();
   
   Comment("\n                                                                                             CountTrades: ",CountTrades(),
           "\n                                                                                             SDGreen: ",SDGreen,
           "\n                                                                                             SDRed: ",SDRed,
           "\n                                                                                             SAR: ",Sar,
           "\n                                                                                             Ask: ",Ask,
           "\n                                                                                             Bid: ",Bid);
  }
//+------------------------------------------------------------------+
